﻿/*-------------------------------------------------------------------------
 Initialize SAKURA-W and Smartcard.
 
 File name   : Controller.cs
 Version     : Version 1.0
 Created     : Apr/01/2011
 Last update : Jun/27/2011
 Desgined by : Toshihiro Katashita
 
 
 Copyright (C) 2011 AIST
 
 By using this code, you agree to the following terms and conditions.
 
 This code is copyrighted by AIST ("us").
 
 Permission is hereby granted to copy, reproduce, redistribute or
 otherwise use this code as long as: there is no monetary profit gained
 specifically from the use or reproduction of this code, it is not sold,
 rented, traded or otherwise marketed, and this copyright notice is
 included prominently in any copy made.
 
 We shall not be liable for any damages, including without limitation
 direct, indirect, incidental, special or consequential damages arising
 from the use of this code.
 
 When you publish any results arising from the use of this code, we will
 appreciate it if you can cite our webpage
 (http://staff.aist.go.jp/akashi.satoh/SASEBO/en/).
 -------------------------------------------------------------------------*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.ComponentModel;
using System.Windows.Forms;

namespace SAKURA_W_VCP_Checker {
  //================================================================ Controller
  class Controller
  {
    //************************************************ Variables
    Random rand;
    int randomseed = 1;
    Tracer.Tracer tracer;
    CipherModule.SAKURA_W_VCP_Card module;

    //------------------------------------------------ Constructor
    public Controller() { rand = new Random(randomseed); }


    //************************************************ 
    //------------------------------------------------ module_setup()
    public string module_setup(string port)
    {
      // st_if and st_module are not used.
      if (module != null)
      {
        module.close();
        module = null;
      }
      module = new CipherModule.SAKURA_W_VCP_Card(port);
      module.open();
      return module.version();
    }

    //------------------------------------------------ tracer_setup()
    public void tracer_setup(string st_num_text, string st_key)
    {
      int num_text = Convert.ToInt32(st_num_text);
      tracer = (Tracer.Tracer)new Tracer.Tracer_SAKURA_W_VCP_Card(module, num_text, st_key);
    }

    //------------------------------------------------ close()
    public void close() { module.close(); }


    //************************************************ 
		//------------------------------------------------ module_addCompletedEventHandler()
    public void tracer_addCompletedEventHandler (RunWorkerCompletedEventHandler handler)
    {
      tracer.addBGWorker_CompletedEventHandler(handler);
    }

		//------------------------------------------------ module_addProgressChangedEventHandler()
    public void tracer_addProgressChangedEventHandler (ProgressChangedEventHandler handler)
    {
      tracer.addBGWorker_ProgressChangedEventHandler(handler);
    }

		//------------------------------------------------ tracer_run()
    public void tracer_run()    { tracer.run(); }

		//------------------------------------------------ tracer_cancel()
    public void tracer_cancel() { tracer.cancel(); }


		//************************************************ 
    public string rand_byteArray(int len) {
      String st = "";
      for (int i=0; i<len; i++) st += (rand.Next(256)).ToString("X2") + " ";
      return st;
    }

  }
}
